{*******************************************************}
{                                                       }
{       xProcs.inc - General Compiler Defines           }
{                                                       }
{       written 1995,98 by Stefan Bther                }
{       mailto:stefc@gmx.net                            }
{       mailto:stefc@t-online.de                        }
{*******************************************************}

(*

   after include this file via {$I xProcs.inc } you'll get
   serveral compiler defines :

     Delphi1 | Delphi2 | Delphi3 | Delphi4 | CBuilder1 | CBuilder3
        - which compiler would be use

     ResStr
        - If this is defined than you can use resource strings directly.
          For example : {$IFNDEF RESSTR}LoadStr{$ENDIF}(SMsgDlgConfirm),

     Scanline
        - the VCL TBitmap class supports the scanline >= Delphi 3

*)

{
  10.05.99 sb Define serveral defines of the Delphi/CBuilder Version that is used
  11.05.99 sb added Scanline define if Compiler >= Delphi 3.0   
}

{$IFDEF VER80}
  {$DEFINE Delphi1}    { Delphi 1.0 }
{$ENDIF}

{$IFDEF VER90}
  {$DEFINE Delphi2}    { Delphi 2.0 }
{$ENDIF}

{$IFDEF VER93}
  {$DEFINE CBuilder1}   { C++Builder 1.0 }
{$ENDIF}

{$IFDEF VER100}         { Delphi 3.0 }
  {$DEFINE RESSTR }
  {$DEFINE ScanLine }
  {$DEFINE Delphi3}
{$ENDIF}

{$IFDEF VER110}         { C++Builder 3.0 }
  {$DEFINE RESSTR }
  {$DEFINE ScanLine }
  {$DEFINE CBuilder3 }
{$ENDIF}

{$IFDEF VER120}         { Delphi 4.0 }
  {$DEFINE RESSTR }
  {$DEFINE ScanLine }
  {$DEFINE Delphi4}
{$ENDIF}

{$IFDEF VER130}         { Delphi 5.0 }
  {$DEFINE RESSTR }
  {$DEFINE ScanLine }
  {$DEFINE Delphi5}
{$ENDIF}




